class DDist:
    def __init__(self, dictionary):
        _sum_vals = sum(dictionary.values())
        if abs(_sum_vals - 1) > 1e-6:
            _e = "Probabilities must sum to 1, not %f\n%r"
            raise Exception(_e % (_sum_vals, dictionary))
        _min = min(dictionary.items(), key=lambda x: x[1])
        if _min[1] < 0:
            e = "Probabilities must be nonnegative (element %r has value %f)\n%r"
            raise Exception(e % (_min + (dictionary,)))
        self.d = dictionary

    def prob(self, elt):
        # replace the following line with your code
        raise NotImplementedError("prob has not been implemented")

    def support(self):
        # replace the following line with your code
        raise NotImplementedError("support has not been implemented")

    def __repr__(self):
        return "DDist(%r)" % self.d
    
    __str__ = __repr__

    def project(self, map_func):
        # replace the following line with your code
        raise NotImplementedError("project has not been implemented")

    def condition(self, test_func):
        # replace the following line with your code
        raise NotImplementedError("condition has not been implemented")

def make_joint_distribution(pr_A, pr_B_given_A):
    # replace the following line with your code
    raise NotImplementedError("make_joint_distribution has not been implemented")

def total_probability(pr_A, pr_B_given_A):
    # replace the following line with your code
    raise NotImplementedError("total_probability has not been implemented")

def bayes_rule(pr_A, pr_B_given_A, b):
    # replace the following line with your code
    raise NotImplementedError("bayes_rules has not been implemented")


### Test Cases:

# Test case 1
print("First test of prob method")
print('Expected:', [0.3,0.5,0.1,0.1])
x = DDist({'b':0.3, 'c':0.5, 'd':0.1, 'e':0.1})
result = [x.prob(i) for i in ['b', 'c', 'd', 'e']]
print('Received:', result)

# Test case 2
print()
print("Test that d.prob(x) is 0 if x is not in the DDist d")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 3
print()
print("First test of support method")
print('Expected:', ['b', 'c', 'd', 'e'])
x = DDist({'b':0.3, 'c':0.5, 'd':0.1, 'e':0.1})
result = list(sorted(x.support()))
print('Received:', result)

# Test case 4
print()
print("Second test of support method")
print('Expected:', False)
x = DDist({'b':0.3, 'c':0.5, 'd':0.1, 'e':0.1})
result = 'B' in x.support()
print('Received:', result)

# Test case 5
print()
print("Test that d.support() does not contain elements with zero probability")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 6
print()
print("Test for make_joint_distribution")
print("Expected: ", DDist({(True, "cat"): 0.07,
                           (True, "dog"): 0.03,
                           (False, "cat"): 0.18,
                           (False, "dog"): 0.72}))
pr_X = DDist({True: 0.1, False: 0.9})
def pr_Y_given_X(x):
    if x:
        return DDist({"cat": 0.7, "dog": 0.3})
    else:
        return DDist({"cat": 0.2, "dog": 0.8})
print("Received:", make_joint_distribution(pr_X, pr_Y_given_X))

# Test case 7
print()
print("Additional test(s) for make_joint_distribution")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 8
print()
print("Test for project")
print('Expected:', DDist({"small": 0.2, "big": 0.8}))
x = DDist({0: 0.1, 1: 0.05, 2: 0.05, 2000: 0.1, 15: 0.7})
def map_func(x):
    if x < 10:
        return "small"
    else:
        return "big"
result = x.project(map_func)
print('Received:', result)

# Test case 9
print()
print("Test case for projection, using square")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 10
print()
print("Test for condition")
print('Expected:', DDist({2000: 0.4, 5: 0.6}))
x = DDist({0: 0.1, 1: 0.1, 2: 0.3, 2000: 0.2, 5: 0.3})
def should_keep(x):
    return x >= 5
result = x.condition(should_keep)
print('Received:', result)

# Test case 11
print()
print("Additional test case(s) for condition")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 12
print()
print("Test for total_probability")
print("Expected: ", DDist({"cat": 0.25,
                           "dog": 0.75}))
pr_X = DDist({True: 0.1, False: 0.9})
def pr_Y_given_X(x):
    if x:
        return DDist({"cat": 0.7, "dog": 0.3})
    else:
        return DDist({"cat": 0.2, "dog": 0.8})
print("Received:", total_probability(pr_X, pr_Y_given_X))

# Test case 13
print()
print("Additional test case(s) for total_probability")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")

# Test case 14
print()
print("Test(s) for bayes_rule")
print('Expected:', "Test Case Not Implemented")
print('Received:', "Test Case Not Implemented")
